const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Review_cyclesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const review_cycles = await db.review_cycles.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        cycle_start: data.cycle_start || null,
        cycle_end: data.cycle_end || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await review_cycles.setOrganizations(data.organizations || null, {
      transaction,
    });

    return review_cycles;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const review_cyclesData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      cycle_start: item.cycle_start || null,
      cycle_end: item.cycle_end || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const review_cycles = await db.review_cycles.bulkCreate(review_cyclesData, {
      transaction,
    });

    // For each item created, replace relation files

    return review_cycles;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const review_cycles = await db.review_cycles.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    if (data.cycle_start !== undefined)
      updatePayload.cycle_start = data.cycle_start;

    if (data.cycle_end !== undefined) updatePayload.cycle_end = data.cycle_end;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await review_cycles.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await review_cycles.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return review_cycles;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const review_cycles = await db.review_cycles.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of review_cycles) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of review_cycles) {
        await record.destroy({ transaction });
      }
    });

    return review_cycles;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const review_cycles = await db.review_cycles.findByPk(id, options);

    await review_cycles.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await review_cycles.destroy({
      transaction,
    });

    return review_cycles;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const review_cycles = await db.review_cycles.findOne(
      { where },
      { transaction },
    );

    if (!review_cycles) {
      return review_cycles;
    }

    const output = review_cycles.get({ plain: true });

    output.reviews_review_cycle = await review_cycles.getReviews_review_cycle({
      transaction,
    });

    output.organizations = await review_cycles.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('review_cycles', 'name', filter.name),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              cycle_start: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              cycle_end: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.cycle_startRange) {
        const [start, end] = filter.cycle_startRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            cycle_start: {
              ...where.cycle_start,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            cycle_start: {
              ...where.cycle_start,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.cycle_endRange) {
        const [start, end] = filter.cycle_endRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            cycle_end: {
              ...where.cycle_end,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            cycle_end: {
              ...where.cycle_end,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.review_cycles.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('review_cycles', 'name', query),
        ],
      };
    }

    const records = await db.review_cycles.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
